/*
 * Student.cpp
 *
 *  Created on: Aug 23, 2011
 *      Author: bdugan
 */

#include "Student.h"

void Student::send(int socket) {
	unsigned char byteArray[1000];
	unsigned char ack[4];
	const int ACKLENGTH=4;
	int bytesReceived = 0;


      	::send((int) socket,(const void *) first.c_str(), (size_t) first.length(),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack

	::send(socket,last.c_str(),last.length(),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack

	::send(socket,address.c_str(),address.length(),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack

	::send(socket,&phone, sizeof(phone),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack

	::send(socket,&gpa, sizeof(gpa),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack

	::send(socket,&year, sizeof(year),0);
	bytesReceived =  recv(socket,ack,ACKLENGTH,0); //ack
}

void Student::receive(int socket) {
	unsigned char byteArray[1000];
	const int ACKLENGTH=4;
	const int BYTEARRAYLENGTH=1000;
	int bytesReceived = 0;
	int ack = 1;

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	first.assign((const char *) byteArray, bytesReceived);
        ::send(socket, &ack, sizeof(ack), 0); // ack

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	last.assign((const char *) byteArray, bytesReceived);
        ::send(socket, &ack, sizeof(ack), 0); // ack

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	address.assign((const char *) byteArray, bytesReceived);
        ::send(socket, &ack, sizeof(ack), 0); // ack

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	((unsigned char *)&phone)[0]=byteArray[0];((unsigned char *)&phone)[1]=byteArray[1];
	((unsigned char *)&phone)[2]=byteArray[2];((unsigned char *)&phone)[3]=byteArray[3];
        ::send(socket, &ack, sizeof(ack), 0); // ack

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	((unsigned char *)&gpa)[0]=byteArray[0];((unsigned char *)&gpa)[1]=byteArray[1];
	((unsigned char *)&gpa)[2]=byteArray[2];((unsigned char *)&gpa)[3]=byteArray[3];
	((unsigned char *)&gpa)[4]=byteArray[4];((unsigned char *)&gpa)[5]=byteArray[5];
	((unsigned char *)&gpa)[6]=byteArray[6];((unsigned char *)&gpa)[7]=byteArray[7];
        ::send(socket, &ack, sizeof(ack), 0); // ack

	bzero(byteArray, BYTEARRAYLENGTH);
	bytesReceived = recv(socket, byteArray, BYTEARRAYLENGTH, 0);
	year=(char) byteArray[0];
        ::send(socket, &ack, sizeof(ack), 0); // ack
}

string Student::toString() {
	stringstream stringStream;
	stringStream << "   first: "   << first << "\n"
				 << "   last: "    << last  << "\n"
				 << "   address: " << address << "\n"
				 << "   phone: "   << phone << "\n"
				 << "   gpa: "     << gpa << "\n"
				 << "   year: "    << year << "\n";

	return stringStream.str();
}


